---
title: <display-inside>
slug: Web/CSS/display-inside
tags:
  - CSS
  - CSS Data Type
  - CSS Display
  - Data Type
  - Reference
  - display-inside
---
<div>{{CSSRef}}</div>

<p class="summary">These keywords specify the element’s inner {{CSSxRef("display")}} type, which defines the type of formatting context that lays out its contents (assuming it is a non-replaced element). These keywords are used as values of the <code>display</code> property, and can be used for legacy purposes as a single keyword, or as defined in the Level 3 specification alongside a value from the {{CSSxRef("&lt;display-outside&gt;")}} keywords.</p>

<h2 id="Syntax">Syntax</h2>

<p>Valid <code>&lt;display-inside&gt;</code> values:</p>

<dl>
 <dt><code>flow</code> {{Experimental_Inline}}</dt>
 <dd>The element lays out its contents using flow layout (block-and-inline layout).
 <p>If its outer display type is <code>inline</code> or <code>run-in</code>, and it is participating in a block or inline formatting context, then it generates an inline box. Otherwise it generates a block container box.</p>

 <p>Depending on the value of other properties (such as {{CSSxRef("position")}}, {{CSSxRef("float")}}, or {{CSSxRef("overflow")}}) and whether it is itself participating in a block or inline formatting context, it either establishes a new <a href="/en-US/docs/Web/Guide/CSS/Block_formatting_context">block formatting context</a> (BFC) for its contents or integrates its contents into its parent formatting context.</p>
 </dd>
 <dt><code>flow-root</code></dt>
 <dd>The element generates a block element box that establishes a new <a href="/en-US/docs/Web/Guide/CSS/Block_formatting_context">block formatting context</a>, defining where the formatting root lies.</dd>
 <dt><code>table</code></dt>
 <dd>These elements behave like HTML {{HTMLElement("table")}} elements. It defines a block-level box.</dd>
 <dt><code>flex</code></dt>
 <dd>The element behaves like a block element and lays out its content according to the <a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout">flexbox model</a>.</dd>
 <dt><code>grid</code></dt>
 <dd>The element behaves like a block element and lays out its content according to the <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Basic_Concepts_of_Grid_Layout">grid model</a>.</dd>
 <dt><code>ruby</code> {{Experimental_Inline}}</dt>
 <dd>The element behaves like an inline element and lays out its content according to the ruby formatting model. It behaves like the corresponding HTML {{HTMLElement("ruby")}} elements.</dd>
</dl>

<div class="note">
<p><strong>Note</strong>: Browsers that support the two value syntax, on finding the inner value only, such as when <code>display: flex</code> or <code>display: grid</code> is specified, will set their outer value to <code>block</code>. This will result in expected behavior; for example if you specify an element to be <code>display: grid</code>, you would expect that the box created on the grid container would be a block level box.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>In this example the parent box has been given <code>display: flow-root</code> and so establishes a new BFC and contains the floated item.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;div class="box"&gt;
  &lt;div class="float"&gt;I am a floated box!&lt;/div&gt;
  &lt;p&gt;I am content inside the container.&lt;/p&gt;
&lt;/div&gt;
</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">.box {
    background-color: rgb(224, 206, 247);
    border: 5px solid rebeccapurple;
    display: flow-root;
}

.float {
    float: left;
    width: 200px;
    height: 150px;
    background-color: white;
    border:1px solid black;
    padding: 10px;
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Examples", "100%", 180)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Display', '#typedef-display-inside', 'display-inside')}}</td>
   <td>{{Spec2('CSS3 Display')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out https://github.com/mdn/browser-compat-data and send us a pull request.</div>

<h3 id="Support_of_multiple_keyword_values">Support of multiple keyword values</h3>

<p>{{Compat("css.properties.display.multi-keyword_values", 10)}}</p>

<ul>
 <li>Chromium bug: <a href="https://bugs.chromium.org/p/chromium/issues/detail?id=804600">https://bugs.chromium.org/p/chromium/issues/detail?id=804600</a></li>
</ul>

<h3 id="Support_of_flow-root">Support of flow-root</h3>

<p>{{Compat("css.properties.display.flow-root", 10)}}</p>

<h3 id="Support_of_table">Support of table</h3>

<p>{{Compat("css.properties.display.table_values", 10)}}</p>

<h3 id="Support_of_grid">Support of grid</h3>

<p>{{Compat("css.properties.display.grid", 10)}}</p>

<h3 id="Support_of_flex">Support of flex</h3>

<p>{{Compat("css.properties.display.flex", 10)}}</p>

<h3 id="Support_of_ruby">Support of ruby</h3>

<p>{{Compat("css.properties.display.ruby_values", 10)}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef("display")}}
  <ul>
   <li>{{CSSxRef("&lt;display-outside&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-listitem&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-internal&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-box&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-legacy&gt;")}}</li>
  </ul>
 </li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Basic_Concepts_of_Flexbox">Basic Concepts of Flexbox</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Basic_Concepts_of_Grid_Layout">Basic Concepts of Grid Layout</a></li>
</ul>
